<?php
/**
 * @copyright Copyright 2009 Glenn Herbert
 * @copyright Portions Copyright 2003-2006 Zen Cart Development Team
 * @copyright Portions Copyright 2003 osCommerce
 * @license http://www.gnu.org/licenses/ GNU Public License V3.0
 * includes/functions/extra_functions/categories_dressing_functions.php
 * Categories Dressing v2.7.3  - Glenn Herbert (gjh42)   - 20090505
 */

function cat_active_level_manage($path) {
  $skip_cat = 0;
  if (defined('CAT_BOX_ACTIVE_LEVEL')) {
    $test_level = 0;
    $cat_box_active_level = explode('|',constant('CAT_BOX_ACTIVE_LEVEL'));
    $cPath_top = (int)$_GET['cPath'];
    $path_top = (int)$path;
    $cat_depth = substr_count($path,'_');
    //tests for various kinds of skipping - more can be added
    switch ($cat_box_active_level[0]){
      case 0:
        $test_level = 1;
        break;
      case 1://active tree only
        if($cPath_top != $path_top) $skip_cat = 1;
        break;
      case 2://active only (all tops when no cat selected)
        if($cPath_top != $path_top and $cPath_top != 0) $skip_cat = 1;
        break;
      case 3://full active tree, others per level
        if($cPath_top != $path_top) $test_level = 1;
        break;
      case 4://like 3, active branches only
        if($cPath_top == $path_top){
          if ($cat_depth >= 2){//only test sub-subcats+
            $path_ids = explode('_',$path);
            $path_parent = $path_ids[count($path_ids)-2];
            if (!in_array($path_parent,explode('_',$_GET['cPath']))) $skip_cat = 1;//show only subcats w parent in $cPath
          }
        } else {//if not active test for level
          $test_level = 1;
        }
        break;
      case 5:// show active, no top, per levels
        if ($cat_depth == 0 or $cPath_top != $path_top) {
          $skip_cat = 1;
        }else{
          $test_level = 1;
        }
        break;
    }//switch
    if ($test_level){
      switch ('true'){
        case ($cat_box_active_level[1] > $cat_depth):
          $skip_cat = 1;
          break;
        case ($cat_box_active_level[2] < $cat_depth):
          $skip_cat = 1;
          break;
      }//switch
    }//if
  }//defined
  return $skip_cat;
}

function cat_ul_manage($current_path, &$prev_cat_depth, $new_group) {
  $ul_content = '';
  $cat_depth = substr_count($current_path,'_');
  $group_id = ' id="catGroup' . $current_path . '"';
  if ($prev_cat_depth < 0) {//first item
    $ul_content .= str_repeat("\n" . '<ul><li>',$cat_depth) . "\n" . '<ul' . $group_id . '>' . "\n";
  } else {
    if ($cat_depth > $prev_cat_depth) {//deeper
      $ul_content .= str_repeat('<ul><li>',($cat_depth - $prev_cat_depth - 1)) . "\n" . '<ul' . $group_id . '>' . "\n";
    } elseif ($cat_depth < $prev_cat_depth) {//higher
       $ul_content .= str_repeat('</li>' . "\n" . '</ul>',($prev_cat_depth - $cat_depth)) . ($new_group?'</li>' . "\n" . '</ul>' . ($cat_depth > 0? '</li>' . "\n" . '  <li>':'') . "\n" . '<ul' . $group_id . '>':'</li>') . "\n";
    } else {//no depth change
      $ul_content .= '</li>' . ($new_group?"\n" . '</ul>' . ($cat_depth > 0? '</li>' . "\n" . '  <li>':'') . "\n" . '<ul' . $group_id . '>':'') . "\n";
    }
  }//if
  $prev_cat_depth = $cat_depth;
  return $ul_content;
}

function cat_box_heading($current_path) {
  $heading_content = '';
  $new_group = 0;
  if (defined('CAT_BOX_HEADING_' . $current_path)) {
    $cat_box_heading = explode('|',constant('CAT_BOX_HEADING_' . $current_path));
    if ($cat_box_heading[0]) {
      $new_group = 1;
    }
    if ($cat_box_heading[1]) {
      $heading_content .= '    <li class="noLi"><hr class="catBoxDivider' . $cat_box_heading[1] . '" /></li>' . "\n"; 
    }
    if ($cat_box_heading[2]) {
      //display image if exists for category name in current language - with title tag
      $heading_content .= '    <li class="noLi">' . (file_exists(DIR_WS_TEMPLATE . 'buttons/' . $_SESSION['language'] . '/' . $cat_box_heading[2]) ? '<div class="catBoxHeadingImg">' . zen_image(DIR_WS_TEMPLATE . 'buttons/' . $_SESSION['language'] . '/' . $cat_box_heading[2], $cat_box_heading[3]) . '</div>':$cat_box_heading[3]) . '</li>' . "\n";
    }
    $i=4;
    while ($i<(sizeof($cat_box_heading)-1)) {
      $heading_content .= '    <li class="noLi"><div class="catBoxHeading' . $cat_box_heading[$i+1] . '">' .  $cat_box_heading[$i] . '</div></li>' . "\n";
      $i = $i+2;
    }
  }
  return array($new_group,$heading_content);
}
    
function cat_name_display($cat_name_display, $current_path) {
  $cat_img_bg = '';
  //display image if exists for category name in current language - with title tag
  if (file_exists(DIR_WS_TEMPLATE . 'buttons/' . $_SESSION['language'] . '/catimg' . $current_path . '.gif')) {
    $cat_name_display = zen_image(DIR_WS_TEMPLATE . 'buttons/' . $_SESSION['language'] . '/catimg' . $current_path . '.gif', '', '', '', 'title="' . $cat_name_display . '"'); 
  //display background image if exists for category name in current language - with title tag
  } elseif (file_exists(DIR_WS_TEMPLATE . 'buttons/' . $_SESSION['language'] . '/catbg' . $current_path . '.gif')) {
    $cat_name_display = zen_image(DIR_WS_TEMPLATE_IMAGES . 'pixel_trans.gif', '', '100%', '100%', 'title="' . $cat_name_display . '"');
    $cat_img_bg = ' catBg' . $current_path;
  } else {
    $cat_img_bg = '-text';//append to main classname
  }
  return array($cat_img_bg, $cat_name_display);
}

function cat_box_subtext($current_path) {
  $subtext = '';
  if (defined('CAT_BOX_SUBTEXT_' . $current_path)) {
    $cat_box_subtext = explode('|',constant('CAT_BOX_SUBTEXT_' . $current_path));
    $subtext .= '<div class="catBoxSubtext' . $cat_box_subtext[1] . '">' . $cat_box_subtext[0] . '</div>';
  }
  return $subtext;
}
?>